#[doc = "Register `CFG15` reader"]
pub struct R(crate::R<CFG15_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<CFG15_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<CFG15_SPEC>> for R {
    fn from(reader: crate::R<CFG15_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `CFG15` writer"]
pub struct W(crate::W<CFG15_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<CFG15_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<CFG15_SPEC>> for W {
    fn from(writer: crate::W<CFG15_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Datapath FIFO Configuration\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum F0_INSEL_A {
    #[doc = "0: No description available"]
    INPUT = 0,
    #[doc = "1: No description available"]
    OUTPUT_A0 = 1,
    #[doc = "2: No description available"]
    OUTPUT_A1 = 2,
    #[doc = "3: No description available"]
    OUTPUT_ALU = 3,
}
impl From<F0_INSEL_A> for u8 {
    #[inline(always)]
    fn from(variant: F0_INSEL_A) -> Self {
        variant as _
    }
}
#[doc = "Field `F0_INSEL` reader - Datapath FIFO Configuration"]
pub struct F0_INSEL_R(crate::FieldReader<u8, F0_INSEL_A>);
impl F0_INSEL_R {
    pub(crate) fn new(bits: u8) -> Self {
        F0_INSEL_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> F0_INSEL_A {
        match self.bits {
            0 => F0_INSEL_A::INPUT,
            1 => F0_INSEL_A::OUTPUT_A0,
            2 => F0_INSEL_A::OUTPUT_A1,
            3 => F0_INSEL_A::OUTPUT_ALU,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `INPUT`"]
    #[inline(always)]
    pub fn is_input(&self) -> bool {
        **self == F0_INSEL_A::INPUT
    }
    #[doc = "Checks if the value of the field is `OUTPUT_A0`"]
    #[inline(always)]
    pub fn is_output_a0(&self) -> bool {
        **self == F0_INSEL_A::OUTPUT_A0
    }
    #[doc = "Checks if the value of the field is `OUTPUT_A1`"]
    #[inline(always)]
    pub fn is_output_a1(&self) -> bool {
        **self == F0_INSEL_A::OUTPUT_A1
    }
    #[doc = "Checks if the value of the field is `OUTPUT_ALU`"]
    #[inline(always)]
    pub fn is_output_alu(&self) -> bool {
        **self == F0_INSEL_A::OUTPUT_ALU
    }
}
impl core::ops::Deref for F0_INSEL_R {
    type Target = crate::FieldReader<u8, F0_INSEL_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `F0_INSEL` writer - Datapath FIFO Configuration"]
pub struct F0_INSEL_W<'a> {
    w: &'a mut W,
}
impl<'a> F0_INSEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: F0_INSEL_A) -> &'a mut W {
        self.bits(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn input(self) -> &'a mut W {
        self.variant(F0_INSEL_A::INPUT)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn output_a0(self) -> &'a mut W {
        self.variant(F0_INSEL_A::OUTPUT_A0)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn output_a1(self) -> &'a mut W {
        self.variant(F0_INSEL_A::OUTPUT_A1)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn output_alu(self) -> &'a mut W {
        self.variant(F0_INSEL_A::OUTPUT_ALU)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x03) | (value as u8 & 0x03);
        self.w
    }
}
#[doc = "Datapath FIFO Configuration\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum F1_INSEL_A {
    #[doc = "0: No description available"]
    INPUT = 0,
    #[doc = "1: No description available"]
    OUTPUT_A0 = 1,
    #[doc = "2: No description available"]
    OUTPUT_A1 = 2,
    #[doc = "3: No description available"]
    OUTPUT_ALU = 3,
}
impl From<F1_INSEL_A> for u8 {
    #[inline(always)]
    fn from(variant: F1_INSEL_A) -> Self {
        variant as _
    }
}
#[doc = "Field `F1_INSEL` reader - Datapath FIFO Configuration"]
pub struct F1_INSEL_R(crate::FieldReader<u8, F1_INSEL_A>);
impl F1_INSEL_R {
    pub(crate) fn new(bits: u8) -> Self {
        F1_INSEL_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> F1_INSEL_A {
        match self.bits {
            0 => F1_INSEL_A::INPUT,
            1 => F1_INSEL_A::OUTPUT_A0,
            2 => F1_INSEL_A::OUTPUT_A1,
            3 => F1_INSEL_A::OUTPUT_ALU,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `INPUT`"]
    #[inline(always)]
    pub fn is_input(&self) -> bool {
        **self == F1_INSEL_A::INPUT
    }
    #[doc = "Checks if the value of the field is `OUTPUT_A0`"]
    #[inline(always)]
    pub fn is_output_a0(&self) -> bool {
        **self == F1_INSEL_A::OUTPUT_A0
    }
    #[doc = "Checks if the value of the field is `OUTPUT_A1`"]
    #[inline(always)]
    pub fn is_output_a1(&self) -> bool {
        **self == F1_INSEL_A::OUTPUT_A1
    }
    #[doc = "Checks if the value of the field is `OUTPUT_ALU`"]
    #[inline(always)]
    pub fn is_output_alu(&self) -> bool {
        **self == F1_INSEL_A::OUTPUT_ALU
    }
}
impl core::ops::Deref for F1_INSEL_R {
    type Target = crate::FieldReader<u8, F1_INSEL_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `F1_INSEL` writer - Datapath FIFO Configuration"]
pub struct F1_INSEL_W<'a> {
    w: &'a mut W,
}
impl<'a> F1_INSEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: F1_INSEL_A) -> &'a mut W {
        self.bits(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn input(self) -> &'a mut W {
        self.variant(F1_INSEL_A::INPUT)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn output_a0(self) -> &'a mut W {
        self.variant(F1_INSEL_A::OUTPUT_A0)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn output_a1(self) -> &'a mut W {
        self.variant(F1_INSEL_A::OUTPUT_A1)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn output_alu(self) -> &'a mut W {
        self.variant(F1_INSEL_A::OUTPUT_ALU)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 2)) | ((value as u8 & 0x03) << 2);
        self.w
    }
}
#[doc = "Arithmetic shift right operation shift in selection\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MSB_SI_A {
    #[doc = "0: No description available"]
    DEFAULT = 0,
    #[doc = "1: No description available"]
    MSB = 1,
}
impl From<MSB_SI_A> for bool {
    #[inline(always)]
    fn from(variant: MSB_SI_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `MSB_SI` reader - Arithmetic shift right operation shift in selection"]
pub struct MSB_SI_R(crate::FieldReader<bool, MSB_SI_A>);
impl MSB_SI_R {
    pub(crate) fn new(bits: bool) -> Self {
        MSB_SI_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> MSB_SI_A {
        match self.bits {
            false => MSB_SI_A::DEFAULT,
            true => MSB_SI_A::MSB,
        }
    }
    #[doc = "Checks if the value of the field is `DEFAULT`"]
    #[inline(always)]
    pub fn is_default(&self) -> bool {
        **self == MSB_SI_A::DEFAULT
    }
    #[doc = "Checks if the value of the field is `MSB`"]
    #[inline(always)]
    pub fn is_msb(&self) -> bool {
        **self == MSB_SI_A::MSB
    }
}
impl core::ops::Deref for MSB_SI_R {
    type Target = crate::FieldReader<bool, MSB_SI_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `MSB_SI` writer - Arithmetic shift right operation shift in selection"]
pub struct MSB_SI_W<'a> {
    w: &'a mut W,
}
impl<'a> MSB_SI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MSB_SI_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn default(self) -> &'a mut W {
        self.variant(MSB_SI_A::DEFAULT)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn msb(self) -> &'a mut W {
        self.variant(MSB_SI_A::MSB)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | ((value as u8 & 0x01) << 4);
        self.w
    }
}
#[doc = "Enable for dynamic control of parallel data input (PI) mux.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PI_DYN_A {
    #[doc = "0: No description available"]
    DISABLE = 0,
    #[doc = "1: No description available"]
    ENABLE = 1,
}
impl From<PI_DYN_A> for bool {
    #[inline(always)]
    fn from(variant: PI_DYN_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PI_DYN` reader - Enable for dynamic control of parallel data input (PI) mux."]
pub struct PI_DYN_R(crate::FieldReader<bool, PI_DYN_A>);
impl PI_DYN_R {
    pub(crate) fn new(bits: bool) -> Self {
        PI_DYN_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PI_DYN_A {
        match self.bits {
            false => PI_DYN_A::DISABLE,
            true => PI_DYN_A::ENABLE,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE`"]
    #[inline(always)]
    pub fn is_disable(&self) -> bool {
        **self == PI_DYN_A::DISABLE
    }
    #[doc = "Checks if the value of the field is `ENABLE`"]
    #[inline(always)]
    pub fn is_enable(&self) -> bool {
        **self == PI_DYN_A::ENABLE
    }
}
impl core::ops::Deref for PI_DYN_R {
    type Target = crate::FieldReader<bool, PI_DYN_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PI_DYN` writer - Enable for dynamic control of parallel data input (PI) mux."]
pub struct PI_DYN_W<'a> {
    w: &'a mut W,
}
impl<'a> PI_DYN_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PI_DYN_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn disable(self) -> &'a mut W {
        self.variant(PI_DYN_A::DISABLE)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn enable(self) -> &'a mut W {
        self.variant(PI_DYN_A::ENABLE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | ((value as u8 & 0x01) << 5);
        self.w
    }
}
#[doc = "Datapath shift out selection\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SHIFT_SEL_A {
    #[doc = "0: No description available"]
    SOL_MSB = 0,
    #[doc = "1: No description available"]
    SOR = 1,
}
impl From<SHIFT_SEL_A> for bool {
    #[inline(always)]
    fn from(variant: SHIFT_SEL_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `SHIFT_SEL` reader - Datapath shift out selection"]
pub struct SHIFT_SEL_R(crate::FieldReader<bool, SHIFT_SEL_A>);
impl SHIFT_SEL_R {
    pub(crate) fn new(bits: bool) -> Self {
        SHIFT_SEL_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SHIFT_SEL_A {
        match self.bits {
            false => SHIFT_SEL_A::SOL_MSB,
            true => SHIFT_SEL_A::SOR,
        }
    }
    #[doc = "Checks if the value of the field is `SOL_MSB`"]
    #[inline(always)]
    pub fn is_sol_msb(&self) -> bool {
        **self == SHIFT_SEL_A::SOL_MSB
    }
    #[doc = "Checks if the value of the field is `SOR`"]
    #[inline(always)]
    pub fn is_sor(&self) -> bool {
        **self == SHIFT_SEL_A::SOR
    }
}
impl core::ops::Deref for SHIFT_SEL_R {
    type Target = crate::FieldReader<bool, SHIFT_SEL_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `SHIFT_SEL` writer - Datapath shift out selection"]
pub struct SHIFT_SEL_W<'a> {
    w: &'a mut W,
}
impl<'a> SHIFT_SEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SHIFT_SEL_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn sol_msb(self) -> &'a mut W {
        self.variant(SHIFT_SEL_A::SOL_MSB)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn sor(self) -> &'a mut W {
        self.variant(SHIFT_SEL_A::SOR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | ((value as u8 & 0x01) << 6);
        self.w
    }
}
#[doc = "Datapath parallel input selection\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PI_SEL_A {
    #[doc = "0: No description available"]
    NORMAL = 0,
    #[doc = "1: No description available"]
    PARALLEL = 1,
}
impl From<PI_SEL_A> for bool {
    #[inline(always)]
    fn from(variant: PI_SEL_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PI_SEL` reader - Datapath parallel input selection"]
pub struct PI_SEL_R(crate::FieldReader<bool, PI_SEL_A>);
impl PI_SEL_R {
    pub(crate) fn new(bits: bool) -> Self {
        PI_SEL_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PI_SEL_A {
        match self.bits {
            false => PI_SEL_A::NORMAL,
            true => PI_SEL_A::PARALLEL,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL`"]
    #[inline(always)]
    pub fn is_normal(&self) -> bool {
        **self == PI_SEL_A::NORMAL
    }
    #[doc = "Checks if the value of the field is `PARALLEL`"]
    #[inline(always)]
    pub fn is_parallel(&self) -> bool {
        **self == PI_SEL_A::PARALLEL
    }
}
impl core::ops::Deref for PI_SEL_R {
    type Target = crate::FieldReader<bool, PI_SEL_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PI_SEL` writer - Datapath parallel input selection"]
pub struct PI_SEL_W<'a> {
    w: &'a mut W,
}
impl<'a> PI_SEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PI_SEL_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn normal(self) -> &'a mut W {
        self.variant(PI_SEL_A::NORMAL)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn parallel(self) -> &'a mut W {
        self.variant(PI_SEL_A::PARALLEL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | ((value as u8 & 0x01) << 7);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:1 - Datapath FIFO Configuration"]
    #[inline(always)]
    pub fn f0_insel(&self) -> F0_INSEL_R {
        F0_INSEL_R::new((self.bits & 0x03) as u8)
    }
    #[doc = "Bits 2:3 - Datapath FIFO Configuration"]
    #[inline(always)]
    pub fn f1_insel(&self) -> F1_INSEL_R {
        F1_INSEL_R::new(((self.bits >> 2) & 0x03) as u8)
    }
    #[doc = "Bit 4 - Arithmetic shift right operation shift in selection"]
    #[inline(always)]
    pub fn msb_si(&self) -> MSB_SI_R {
        MSB_SI_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Enable for dynamic control of parallel data input (PI) mux."]
    #[inline(always)]
    pub fn pi_dyn(&self) -> PI_DYN_R {
        PI_DYN_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Datapath shift out selection"]
    #[inline(always)]
    pub fn shift_sel(&self) -> SHIFT_SEL_R {
        SHIFT_SEL_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Datapath parallel input selection"]
    #[inline(always)]
    pub fn pi_sel(&self) -> PI_SEL_R {
        PI_SEL_R::new(((self.bits >> 7) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bits 0:1 - Datapath FIFO Configuration"]
    #[inline(always)]
    pub fn f0_insel(&mut self) -> F0_INSEL_W {
        F0_INSEL_W { w: self }
    }
    #[doc = "Bits 2:3 - Datapath FIFO Configuration"]
    #[inline(always)]
    pub fn f1_insel(&mut self) -> F1_INSEL_W {
        F1_INSEL_W { w: self }
    }
    #[doc = "Bit 4 - Arithmetic shift right operation shift in selection"]
    #[inline(always)]
    pub fn msb_si(&mut self) -> MSB_SI_W {
        MSB_SI_W { w: self }
    }
    #[doc = "Bit 5 - Enable for dynamic control of parallel data input (PI) mux."]
    #[inline(always)]
    pub fn pi_dyn(&mut self) -> PI_DYN_W {
        PI_DYN_W { w: self }
    }
    #[doc = "Bit 6 - Datapath shift out selection"]
    #[inline(always)]
    pub fn shift_sel(&mut self) -> SHIFT_SEL_W {
        SHIFT_SEL_W { w: self }
    }
    #[doc = "Bit 7 - Datapath parallel input selection"]
    #[inline(always)]
    pub fn pi_sel(&mut self) -> PI_SEL_W {
        PI_SEL_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Datapath FIFO, shift and parallel input control\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cfg15](index.html) module"]
pub struct CFG15_SPEC;
impl crate::RegisterSpec for CFG15_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [cfg15::R](R) reader structure"]
impl crate::Readable for CFG15_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [cfg15::W](W) writer structure"]
impl crate::Writable for CFG15_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets CFG15 to value 0"]
impl crate::Resettable for CFG15_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
